/*
 * Created by SharpDevelop.
 * User: Vedran Vidovic
 * Date: 10.11.2005
 * Time: 11:28
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Drawing;
using System.Windows.Forms;

using ICSharpCode.SharpZipLib.Zip;

namespace vedran.mobookpacker
{
	
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox txtbxTxtFile;
		private System.Windows.Forms.TextBox txtbxBookName;
		private System.Windows.Forms.Button btnHelp;
		private System.Windows.Forms.Label lblMaxJarFileSize;
		private System.Windows.Forms.Label lblTargetDir;
		private System.Windows.Forms.OpenFileDialog openFileDialogTxt;
		private System.Windows.Forms.Label lblBookName;
		private System.Windows.Forms.CheckBox chbSkipSingleNewLine;
		private System.Windows.Forms.Button btnCreateMidlet;
		private System.Windows.Forms.Label lblTxtFile;
		private System.Windows.Forms.OpenFileDialog openFileDialogCover;
		private System.Windows.Forms.TextBox txtbxMaxJarFileSize;
		private System.Windows.Forms.CheckBox chbSplitJarJadFiles;
		private System.Windows.Forms.TextBox txtbxBookEncoding;
		private System.Windows.Forms.Label lblCoverImage;
		private System.Windows.Forms.Button btnTxtFile;
		private System.Windows.Forms.CheckBox chbMax1Blank;
		private System.Windows.Forms.Label lblTxtEncoding;
		private System.Windows.Forms.ComboBox cmbMaxJarFileSize;
		private System.Windows.Forms.Button btnTargetDir;
		private System.Windows.Forms.TextBox txtbxCoverImage;
		private System.Windows.Forms.Button btnCoverImage;
		private System.Windows.Forms.TextBox txtbxTargetDir;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialogDir;
		private const string VERSION = "2.1";
		private const string STR_HELP =
			"MoBookPackerWin ver. " + VERSION + "\n\n" +
			"This program is used to make book viewable on mobile devices supporting J2ME MIDP 1.0.\n" +
			"It packs your plain txt file with MoBook MIDlet which can be uploaded to mobile device\n" +
			"as any other mobile java application.\n\n" +
			"USAGE:\n" +
			"1. (Optional) Set name which will be used for packed MIDlet (if empty, text file name will be used).\n" +
			"2. Choose target dir where to put jad and jar files.\n" +
			"3. Choose plain txt file which will be displayed in MIDlet.\n" +
			"4. (Optional) Choose book cover image (png format!).\n" +
			"5. (Optional) Enter book encoding (UTF-8,..). Text file which is packed have to be\n" +
			"   saved in entered encoding and mobile device have to support same encoding.\n" +
			"   If mobile device doesn't support this encoding it will read text file using it's\n" +
			"   default encoding.\n" +
			"6. Press 'create MIDlet' button to create jad and jar files in target dir.\n" +
			"7. (Optional) If you selected \"Split jar/jad files\" checkbox and windows with text are shown,\n" +
			"   set text cursor to positions where you want to split files.\n\n" +
			"OPTIONS:\n" +
			"First option enables you to convert multiple blank lines in text to single blank line.\n" +
			"Second option enables you to convert all single newline chars in text to space chars\n" +
			"(because text lines are any way reformated to fit on small screen of mobile device).\n" +
			"Third option enables you to split book in more than one file automaticaly to avoid\n" +
			"problems with maximum jar files limit on your mobile phone.\n\n" +
			"LICENCE:\n" +
			"MoBook and MoBookPacker can be used on any number of devices (mobile and pc) but is\n" +
			"distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND,\n" +
			"either express or implied.\n\n" +
			"You can change them or use them inside your own programs, but in that case text with\n" +
			"note about usage of MoBook and/or MoBookPacker and name of their author have to be\n" +
			"easily reachable from within new programs.\n\n" +
			"Copyright (C) Vedran Vidovic 2005, all Rights Reserved.";
		// This is size which works with MoBookPacker version 1.4.
		private const long EMPTY_BOOK_SIZE = 16000;
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		[STAThread]
		public static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.folderBrowserDialogDir = new System.Windows.Forms.FolderBrowserDialog();
			this.txtbxTargetDir = new System.Windows.Forms.TextBox();
			this.btnCoverImage = new System.Windows.Forms.Button();
			this.txtbxCoverImage = new System.Windows.Forms.TextBox();
			this.btnTargetDir = new System.Windows.Forms.Button();
			this.cmbMaxJarFileSize = new System.Windows.Forms.ComboBox();
			this.lblTxtEncoding = new System.Windows.Forms.Label();
			this.chbMax1Blank = new System.Windows.Forms.CheckBox();
			this.btnTxtFile = new System.Windows.Forms.Button();
			this.lblCoverImage = new System.Windows.Forms.Label();
			this.txtbxBookEncoding = new System.Windows.Forms.TextBox();
			this.chbSplitJarJadFiles = new System.Windows.Forms.CheckBox();
			this.txtbxMaxJarFileSize = new System.Windows.Forms.TextBox();
			this.openFileDialogCover = new System.Windows.Forms.OpenFileDialog();
			this.lblTxtFile = new System.Windows.Forms.Label();
			this.btnCreateMidlet = new System.Windows.Forms.Button();
			this.chbSkipSingleNewLine = new System.Windows.Forms.CheckBox();
			this.lblBookName = new System.Windows.Forms.Label();
			this.openFileDialogTxt = new System.Windows.Forms.OpenFileDialog();
			this.lblTargetDir = new System.Windows.Forms.Label();
			this.lblMaxJarFileSize = new System.Windows.Forms.Label();
			this.btnHelp = new System.Windows.Forms.Button();
			this.txtbxBookName = new System.Windows.Forms.TextBox();
			this.txtbxTxtFile = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// folderBrowserDialogDir
			// 
			this.folderBrowserDialogDir.SelectedPath = ".";
			// 
			// txtbxTargetDir
			// 
			this.txtbxTargetDir.Location = new System.Drawing.Point(216, 80);
			this.txtbxTargetDir.Name = "txtbxTargetDir";
			this.txtbxTargetDir.Size = new System.Drawing.Size(264, 20);
			this.txtbxTargetDir.TabIndex = 7;
			this.txtbxTargetDir.Text = "";
			// 
			// btnCoverImage
			// 
			this.btnCoverImage.Location = new System.Drawing.Point(488, 56);
			this.btnCoverImage.Name = "btnCoverImage";
			this.btnCoverImage.Size = new System.Drawing.Size(56, 21);
			this.btnCoverImage.TabIndex = 9;
			this.btnCoverImage.Text = "set";
			this.btnCoverImage.Click += new System.EventHandler(this.BtnCoverImageClick);
			// 
			// txtbxCoverImage
			// 
			this.txtbxCoverImage.Location = new System.Drawing.Point(216, 56);
			this.txtbxCoverImage.Name = "txtbxCoverImage";
			this.txtbxCoverImage.Size = new System.Drawing.Size(264, 20);
			this.txtbxCoverImage.TabIndex = 6;
			this.txtbxCoverImage.Text = "";
			// 
			// btnTargetDir
			// 
			this.btnTargetDir.Location = new System.Drawing.Point(488, 80);
			this.btnTargetDir.Name = "btnTargetDir";
			this.btnTargetDir.Size = new System.Drawing.Size(56, 21);
			this.btnTargetDir.TabIndex = 10;
			this.btnTargetDir.Text = "set";
			this.btnTargetDir.Click += new System.EventHandler(this.BtnTargetDirClick);
			// 
			// cmbMaxJarFileSize
			// 
			this.cmbMaxJarFileSize.DisplayMember = "KB";
			this.cmbMaxJarFileSize.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cmbMaxJarFileSize.Items.AddRange(new object[] {
						"B",
						"KB",
						"MB"});
			this.cmbMaxJarFileSize.Location = new System.Drawing.Point(248, 216);
			this.cmbMaxJarFileSize.Name = "cmbMaxJarFileSize";
			this.cmbMaxJarFileSize.Size = new System.Drawing.Size(121, 21);
			this.cmbMaxJarFileSize.TabIndex = 17;
			// 
			// lblTxtEncoding
			// 
			this.lblTxtEncoding.Location = new System.Drawing.Point(56, 128);
			this.lblTxtEncoding.Name = "lblTxtEncoding";
			this.lblTxtEncoding.Size = new System.Drawing.Size(128, 16);
			this.lblTxtEncoding.TabIndex = 20;
			this.lblTxtEncoding.Text = "Choose book encoding:";
			// 
			// chbMax1Blank
			// 
			this.chbMax1Blank.Location = new System.Drawing.Point(56, 160);
			this.chbMax1Blank.Name = "chbMax1Blank";
			this.chbMax1Blank.Size = new System.Drawing.Size(368, 16);
			this.chbMax1Blank.TabIndex = 12;
			this.chbMax1Blank.Text = "Max 1 blank line";
			// 
			// btnTxtFile
			// 
			this.btnTxtFile.Location = new System.Drawing.Point(488, 104);
			this.btnTxtFile.Name = "btnTxtFile";
			this.btnTxtFile.Size = new System.Drawing.Size(56, 21);
			this.btnTxtFile.TabIndex = 11;
			this.btnTxtFile.Text = "set";
			this.btnTxtFile.Click += new System.EventHandler(this.BtnTxtFileClick);
			// 
			// lblCoverImage
			// 
			this.lblCoverImage.Location = new System.Drawing.Point(56, 56);
			this.lblCoverImage.Name = "lblCoverImage";
			this.lblCoverImage.Size = new System.Drawing.Size(144, 16);
			this.lblCoverImage.TabIndex = 2;
			this.lblCoverImage.Text = "Choose cover image (png):";
			// 
			// txtbxBookEncoding
			// 
			this.txtbxBookEncoding.Location = new System.Drawing.Point(216, 128);
			this.txtbxBookEncoding.Name = "txtbxBookEncoding";
			this.txtbxBookEncoding.Size = new System.Drawing.Size(264, 20);
			this.txtbxBookEncoding.TabIndex = 21;
			this.txtbxBookEncoding.Text = "";
			// 
			// chbSplitJarJadFiles
			// 
			this.chbSplitJarJadFiles.Location = new System.Drawing.Point(408, 216);
			this.chbSplitJarJadFiles.Name = "chbSplitJarJadFiles";
			this.chbSplitJarJadFiles.Size = new System.Drawing.Size(112, 24);
			this.chbSplitJarJadFiles.TabIndex = 18;
			this.chbSplitJarJadFiles.Text = "Split jar/jad files";
			this.chbSplitJarJadFiles.CheckedChanged += new System.EventHandler(this.ChbSplitCheckedChanged);
			// 
			// txtbxMaxJarFileSize
			// 
			this.txtbxMaxJarFileSize.Location = new System.Drawing.Point(160, 216);
			this.txtbxMaxJarFileSize.Name = "txtbxMaxJarFileSize";
			this.txtbxMaxJarFileSize.Size = new System.Drawing.Size(80, 20);
			this.txtbxMaxJarFileSize.TabIndex = 16;
			this.txtbxMaxJarFileSize.Text = "64";
			// 
			// openFileDialogCover
			// 
			this.openFileDialogCover.Filter = "Png image files|*.png";
			this.openFileDialogCover.InitialDirectory = ".";
			// 
			// lblTxtFile
			// 
			this.lblTxtFile.Location = new System.Drawing.Point(56, 104);
			this.lblTxtFile.Name = "lblTxtFile";
			this.lblTxtFile.Size = new System.Drawing.Size(112, 16);
			this.lblTxtFile.TabIndex = 4;
			this.lblTxtFile.Text = "Choose book txt file:";
			// 
			// btnCreateMidlet
			// 
			this.btnCreateMidlet.Location = new System.Drawing.Point(56, 248);
			this.btnCreateMidlet.Name = "btnCreateMidlet";
			this.btnCreateMidlet.Size = new System.Drawing.Size(488, 24);
			this.btnCreateMidlet.TabIndex = 19;
			this.btnCreateMidlet.Text = "create MIDlet(s)";
			this.btnCreateMidlet.Click += new System.EventHandler(this.BtnCreateMidletClick);
			// 
			// chbSkipSingleNewLine
			// 
			this.chbSkipSingleNewLine.Location = new System.Drawing.Point(56, 184);
			this.chbSkipSingleNewLine.Name = "chbSkipSingleNewLine";
			this.chbSkipSingleNewLine.Size = new System.Drawing.Size(368, 16);
			this.chbSkipSingleNewLine.TabIndex = 13;
			this.chbSkipSingleNewLine.Text = "Skip single new line chars";
			// 
			// lblBookName
			// 
			this.lblBookName.Location = new System.Drawing.Point(56, 32);
			this.lblBookName.Name = "lblBookName";
			this.lblBookName.Size = new System.Drawing.Size(128, 16);
			this.lblBookName.TabIndex = 1;
			this.lblBookName.Text = "Midlet (book) name:";
			// 
			// openFileDialogTxt
			// 
			this.openFileDialogTxt.InitialDirectory = ".";
			// 
			// lblTargetDir
			// 
			this.lblTargetDir.Location = new System.Drawing.Point(56, 80);
			this.lblTargetDir.Name = "lblTargetDir";
			this.lblTargetDir.Size = new System.Drawing.Size(112, 16);
			this.lblTargetDir.TabIndex = 3;
			this.lblTargetDir.Text = "Choose target dir:";
			// 
			// lblMaxJarFileSize
			// 
			this.lblMaxJarFileSize.Location = new System.Drawing.Point(56, 216);
			this.lblMaxJarFileSize.Name = "lblMaxJarFileSize";
			this.lblMaxJarFileSize.Size = new System.Drawing.Size(88, 16);
			this.lblMaxJarFileSize.TabIndex = 15;
			this.lblMaxJarFileSize.Text = "Max jar file size:";
			// 
			// btnHelp
			// 
			this.btnHelp.Location = new System.Drawing.Point(488, 8);
			this.btnHelp.Name = "btnHelp";
			this.btnHelp.Size = new System.Drawing.Size(56, 21);
			this.btnHelp.TabIndex = 0;
			this.btnHelp.Text = "help";
			this.btnHelp.Click += new System.EventHandler(this.BtnHelpClick);
			// 
			// txtbxBookName
			// 
			this.txtbxBookName.Location = new System.Drawing.Point(216, 32);
			this.txtbxBookName.Name = "txtbxBookName";
			this.txtbxBookName.Size = new System.Drawing.Size(264, 20);
			this.txtbxBookName.TabIndex = 5;
			this.txtbxBookName.Text = "";
			// 
			// txtbxTxtFile
			// 
			this.txtbxTxtFile.Location = new System.Drawing.Point(216, 104);
			this.txtbxTxtFile.Name = "txtbxTxtFile";
			this.txtbxTxtFile.Size = new System.Drawing.Size(264, 20);
			this.txtbxTxtFile.TabIndex = 8;
			this.txtbxTxtFile.Text = "";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 278);
			this.Controls.Add(this.txtbxBookEncoding);
			this.Controls.Add(this.lblTxtEncoding);
			this.Controls.Add(this.btnCreateMidlet);
			this.Controls.Add(this.chbSplitJarJadFiles);
			this.Controls.Add(this.cmbMaxJarFileSize);
			this.Controls.Add(this.txtbxMaxJarFileSize);
			this.Controls.Add(this.lblMaxJarFileSize);
			this.Controls.Add(this.chbSkipSingleNewLine);
			this.Controls.Add(this.chbMax1Blank);
			this.Controls.Add(this.btnTxtFile);
			this.Controls.Add(this.btnTargetDir);
			this.Controls.Add(this.btnCoverImage);
			this.Controls.Add(this.txtbxTxtFile);
			this.Controls.Add(this.txtbxTargetDir);
			this.Controls.Add(this.txtbxCoverImage);
			this.Controls.Add(this.txtbxBookName);
			this.Controls.Add(this.lblTxtFile);
			this.Controls.Add(this.lblTargetDir);
			this.Controls.Add(this.lblCoverImage);
			this.Controls.Add(this.lblBookName);
			this.Controls.Add(this.btnHelp);
			this.Name = "MainForm";
			this.Text = "MoBookPacker";
			this.Load += new System.EventHandler(this.MainFormLoad);
			this.ResumeLayout(false);
		}
		#endregion
		
		void MainFormLoad(object sender, System.EventArgs e)
		{
			this.Text += " " + VERSION;
			this.cmbMaxJarFileSize.SelectedIndex = 1;
			EnableSplit(true);
			string dirPath = Application.ExecutablePath;
			dirPath = dirPath.Substring(0, dirPath.LastIndexOf('\\'));
			this.folderBrowserDialogDir.SelectedPath = dirPath;
			this.txtbxTargetDir.Text = dirPath;
		}
		
		void BtnHelpClick(object sender, System.EventArgs e)
		{
			MessageBox.Show(STR_HELP);
		}
		
		void BtnSetCoverImageClick(object sender, System.EventArgs e)
		{
			MessageBox.Show(this.cmbMaxJarFileSize.SelectedIndex.ToString());
			
		}
		
		
		void ChbSplitCheckedChanged(object sender, System.EventArgs e)
		{
			EnableSplit(this.chbSplitJarJadFiles.Checked);
		}
		void EnableSplit(bool enable) {
			this.chbSplitJarJadFiles.Checked = enable;
			this.lblMaxJarFileSize.Enabled = enable;
			this.txtbxMaxJarFileSize.Enabled = enable;
			this.cmbMaxJarFileSize.Enabled = enable;
		}
		
		////<summary>
		/// This method handles main button click ("create MIDlet(s)").
		/// If everything is correct we call another method to
		/// actually create midlet(s), otherwise we show error dialog.
		/// </summary>
		void BtnCreateMidletClick(object sender, System.EventArgs e)
		{
			string txtDirPath = this.txtbxTargetDir.Text;
			if(txtDirPath.Length > 0 &&
			   System.IO.Directory.Exists(txtDirPath)) {
				string txtFilePath = this.txtbxTxtFile.Text;
				if(txtFilePath.Length > 0 && System.IO.File.Exists(txtFilePath)) {
					string txtCoverPath = this.txtbxCoverImage.Text;
					if(txtCoverPath.Length > 0) {
						if(!System.IO.File.Exists(txtCoverPath)) {
							txtCoverPath = "";
							MessageBox.Show(this, "wrong cover file path, skipping cover file!");
						}
					}
					string txtBookName = txtbxBookName.Text;
					if(txtBookName.Length == 0) {
						txtBookName = System.IO.Path.GetFileNameWithoutExtension(txtFilePath);
					}
					
					long splitSize = 0;
					if(this.chbSplitJarJadFiles.Checked) {
						string txtSplitSize = this.txtbxMaxJarFileSize.Text;
						try {
							splitSize = System.Int64.Parse(txtSplitSize);
							switch(this.cmbMaxJarFileSize.SelectedIndex) {
								case 1:
									splitSize *= 1024;
									break;
								case 2:
									splitSize *= 1024*1024;
									break;
							}
							if(splitSize < EMPTY_BOOK_SIZE) {
								splitSize = 0;
								EnableSplit(false);
								MessageBox.Show("Maximum jar file size have to be at least " +
								                EMPTY_BOOK_SIZE + " B!\nDisabling splitting.");
							}
						}
						catch(Exception ex) {
							MessageBox.Show("wrong jar split number format('" +
							                txtSplitSize + "'): " + ex.Message);
						}
					}
					
					createMidlet(txtDirPath, txtFilePath, txtCoverPath, txtBookName,
					             splitSize);
				}
				else {
					MessageBox.Show(this, "please select text file to pack!");
				}
			}
			else {
				MessageBox.Show(this, "please select target directory!");
			}
		}
		
		////<summary>
		/// Creates midlet(s) with selected parameters. If splitSize is 0 we don't
		/// split file.
		/// </summary>
		/// <param name="splitSize">
		/// Max size of jar file in bytes.
		/// </param>
		private void createMidlet(string targetDirPath, string bookPath, string coverPath,
		                  string bookName, long splitSize) {
			long jarSize;
			if(splitSize == 0) {
				jarSize = createMidlet(targetDirPath, bookPath, coverPath, bookName, 0, 0, 0);
			}
			else {
				jarSize = createMidlet(targetDirPath, bookPath, coverPath, bookName, 0, 0, 0);
				if(jarSize > splitSize) {
					deleteJadJarFiles(targetDirPath, bookName, 0);
					long txtFileSize = new System.IO.FileInfo(bookPath).Length;
					int fileNo = 1;
					long txtStartByte = 0;
					long newTextSize = txtFileSize * (splitSize - EMPTY_BOOK_SIZE) / (jarSize - EMPTY_BOOK_SIZE);
					long txtLengthBytes = txtStartByte + newTextSize;
					
					bool finnished = false;
					// If our jar is bigger than max jar file size, try again.
					// If our text is not finnished and jar file is not near split size, try again.
					//while(jarSize > splitSize ||
					      //(jarSize + 1024 < splitSize && txtStartByte + txtLengthBytes < txtFileSize )) {
					while(!finnished) {
						jarSize = createMidlet(targetDirPath, bookPath, coverPath, bookName,
						                       fileNo, txtStartByte, txtLengthBytes);
					    // File too big, try again.
					    // File smaller or equal splitSize, but not more than 1K. User chooses exact place to split, next file.
					    // File smaller or equal splitSize, but more than 1K smaller. Try again.
					    // Last file, finnish.
						if(jarSize > splitSize) {
							txtLengthBytes -= 1024;
						}
				      	else if(jarSize + 1024 >= splitSize) {
							System.Text.StringBuilder sb = new System.Text.StringBuilder();
							System.IO.BufferedStream bis =
								new System.IO.BufferedStream(new System.IO.FileStream(
								bookPath, System.IO.FileMode.Open));
							skip(bis, txtStartByte);
							int ch = bis.ReadByte();
							long count = 1;
							while(ch != -1 && count < txtLengthBytes) {
								sb.Append((char)ch);
								ch = bis.ReadByte();
								count++;
							}
							bis.Close();
							
							FormSplitPosition form = new FormSplitPosition();
							form.SetText(sb.ToString());
							
							form.ShowDialog();
							int caretPos = form.GetCaretPosition();
							// Problem is that caret and byte pos are not same!
							// Maybe only because of newline chars...
							bis =
								new System.IO.BufferedStream(new System.IO.FileStream(
								bookPath, System.IO.FileMode.Open));
							skip(bis, txtStartByte);
							ch = bis.ReadByte();
							count = 1;
							int chLast = -1;
							long newLineCount = 0;
							while(ch != -1 && count <= caretPos + newLineCount + 1) {
								// Add one for each '0d 0a' newlines because we use only '0a' and
								// we got wrong number for byte position.
								if(chLast == 0x0d && ch == 0x0a) {
									newLineCount++;
								}
								chLast = ch;
								ch = bis.ReadByte();
								count++;
							}
							bis.Close();
							
							/*MessageBox.Show(caretPos +
							               ", len = " + txtLengthBytes +
							               ", caret + newlines: " + (caretPos + newLineCount) +
							              ", caret: " + caretPos +
							             ", count: " + count +
							            ", newlinecount: " + newLineCount);*/
					    	
							createMidlet(targetDirPath, bookPath, coverPath, bookName,
						                       fileNo, txtStartByte, caretPos + newLineCount);
				      		//txtStartByte += txtLengthBytes;
				      		txtStartByte += caretPos + newLineCount;
				      		fileNo ++;
				      	}
						else if(jarSize + 1024 < splitSize &&
					            txtStartByte + txtLengthBytes < txtFileSize ) {
							txtLengthBytes += 512;
						}
						else {
							finnished = true;
						}
					}

				}
			}
			MessageBox.Show("Finnished!");
		}
		private string createJarPath(string targetDirPath, string bookName, int fileNo) {
			return createJadJarPathBase(targetDirPath, bookName, fileNo) + ".jar";
		}
		private string createJadPath(string targetDirPath, string bookName, int fileNo) {
			return createJadJarPathBase(targetDirPath, bookName, fileNo) + ".jad";
		}
		private string createJadJarPathBase(string targetDirPath, string bookName, int fileNo) {
			string noSuffix = "";
			if(fileNo != 0) {
				noSuffix = fileNo.ToString();
			}
			return targetDirPath + "\\" + bookName + noSuffix;
		}
		private void deleteJadJarFiles(string targetDirPath, string bookName, int fileNo) {
			System.IO.File.Delete(createJadPath(targetDirPath, bookName, fileNo));
			System.IO.File.Delete(createJarPath(targetDirPath, bookName, fileNo));
		}
		////<summary>
		/// Creates one of jar files with selected paremeters.
		/// </summary>
		/// <returns>
		/// Size of created jar file.
		/// </returns>
		long createMidlet(string targetDirPath, string bookPath, string coverPath,
		                  string bookName,
		                  int jarNo, long txtStartByte, long txtLengthBytes) {
			string outputPrefixPath = targetDirPath + "\\" + bookName;
			string jarPath = createJarPath(targetDirPath, bookName, jarNo);
			string jadPath = createJadPath(targetDirPath, bookName, jarNo);
			System.IO.FileStream fos = new System.IO.FileStream(jarPath, System.IO.FileMode.Create);
			// Create new jar file in which we will pack book + mobook...
			System.IO.BufferedStream bos = new System.IO.BufferedStream(fos);
			ZipOutputStream zos = new ZipOutputStream(bos);
			
			string line;
						
			System.Reflection.Assembly assembly = System.Reflection.Assembly.GetExecutingAssembly();
			System.IO.Stream stream = assembly.GetManifestResourceStream("MoBook.jar");
			ZipInputStream zis = new ZipInputStream(stream);
			ZipEntry zipEntry = zis.GetNextEntry();
			while(zipEntry != null) {
				if(!zipEntry.IsDirectory) {
					string entryName = zipEntry.Name;
					if(entryName.EndsWith(".universal") ||
						entryName.EndsWith(".nokia")) {
						entryName = entryName.Substring(0, entryName.LastIndexOf('.'));
					}
					// Create new entry for every original entry, but change name for
					// our platform specific file.
					ZipEntry zipEntryNew = new ZipEntry(entryName);
          			zipEntryNew.Comment = zipEntry.Comment;
					//zipEntryNew.CompressedSize = zipEntry.CompressedSize;
					zipEntryNew.ExtraData = zipEntry.ExtraData;
					zipEntryNew.CompressionMethod = zipEntry.CompressionMethod;
					zipEntryNew.DateTime = zipEntry.DateTime;
					
					zos.PutNextEntry(zipEntryNew);
					if(zipEntry.Name.EndsWith("MANIFEST.MF")) {
						System.IO.BufferedStream bs = new System.IO.BufferedStream(zis);
						System.IO.StreamReader isr = new System.IO.StreamReader(bs);

						line = isr.ReadLine();
						while(line != null) {
							if(line.StartsWith("MIDlet-Name:")) {
								string nameSuffix = "";
								if(jarNo > 0) {
									nameSuffix = jarNo.ToString();
								}
								line = "MIDlet-Name: " + bookName + nameSuffix;
							}
							char[] carr = line.ToCharArray();
							for(int i=0; i<carr.Length; i++) {
								zos.WriteByte((byte)carr[i]);
							}
							zos.WriteByte((byte)'\n');
							line = isr.ReadLine();
						}
					}
					else {
						int c = zis.ReadByte();
						while(c != -1) {
							zos.WriteByte((byte)c);
							c = zis.ReadByte();
						}
					}
					zos.CloseEntry();
				}
				
				zipEntry = zis.GetNextEntry();
			}
			zis.Close();
			
			System.IO.BufferedStream bis;
			int ch;
			
			// create new entry for cover if fCover != null
			if(coverPath.Length > 0) {
				ZipEntry zipEntryCover = new ZipEntry("cover.png");
				zos.PutNextEntry(zipEntryCover);
				bis = new System.IO.BufferedStream(new System.IO.FileStream(coverPath, System.IO.FileMode.Open));
				ch = bis.ReadByte();
				while(ch != -1) {
					zos.WriteByte((byte)ch);
					ch = bis.ReadByte();
				}
				zos.CloseEntry();
				bis.Close();
			}
			
			
			// create new entry for book
			ZipEntry zipEntryBook = new ZipEntry("book.txt");
			//zipEntryBook.setSize(fBook.length());
			zos.PutNextEntry(zipEntryBook);
			bis =
				new System.IO.BufferedStream(new System.IO.FileStream(
				                  bookPath, System.IO.FileMode.Open));
			skip(bis, txtStartByte);
			
			ch = bis.ReadByte();
			int cntNewline = 0; // No of new lines read.
			bool max1blank = chbMax1Blank.Checked;
			bool skipSingleNewline = chbSkipSingleNewLine.Checked;
			int lastCharWritten = 0;
			bool lastCharWasNewline = false;
			int chLast = -1;
			
			long charCnt = 0;
			while(ch != -1 && (txtLengthBytes == 0 || charCnt < txtLengthBytes)) {
				// CR-LF variant, skip second char
				if(ch != 0x0a || chLast != 0x0d) {
					bool newLineCurrent = false;
					if(ch == ' ' && lastCharWritten == ' ') {
					}
					else {
						if(ch == 0x0a || ch == 0x0d) {
							cntNewline++;
							newLineCurrent = true;
						}
						else {
							cntNewline = 0;
						}
						
						if(cntNewline == 0) {
							if(skipSingleNewline && lastCharWasNewline) {
								zos.WriteByte((byte)' ');
							}
							if(!skipSingleNewline || !lastCharWasNewline || ch != ' ') {
								zos.WriteByte((byte)ch);
							}
							lastCharWritten = ch;
						}
						else if(cntNewline == 1) {
							if(!skipSingleNewline) {
								zos.WriteByte((byte)'\n');
								lastCharWritten = ch;
							}
						}
						else if(cntNewline == 2) {
							zos.WriteByte((byte)'\n');
							lastCharWritten = ch;
							// Last newline was skipped in this cse
							if(skipSingleNewline) {
								zos.WriteByte((byte)'\n');
								lastCharWritten = ch;
							}
						}
						else { // cntNewline > 2
							if(!max1blank) {
								zos.WriteByte((byte)'\n');
								lastCharWritten = ch;
							}
						}
					}
					lastCharWasNewline = newLineCurrent;
				}
				chLast = ch;
				ch = bis.ReadByte();
				charCnt++;
			}
			zos.CloseEntry();
			bis.Close();

			//zos.Flush();
			zos.Close();
			
			assembly = System.Reflection.Assembly.GetExecutingAssembly();
			stream = assembly.GetManifestResourceStream("MoBook.jad");
			System.IO.BufferedStream bisMoBookJad = new System.IO.BufferedStream(stream);
			System.IO.StreamReader sr = new System.IO.StreamReader(bisMoBookJad);

			fos = new System.IO.FileStream(jadPath, System.IO.FileMode.Create);
			bos = new System.IO.BufferedStream(fos);
			System.IO.StreamWriter sw = new System.IO.StreamWriter(bos);
			

      		line = sr.ReadLine();
      		
			bool bookSizeExists = false;
			long jarFileSize = new System.IO.FileInfo(jarPath).Length;
			while(line != null && line.Length != 0) {
				string nameSuffix = "";
				if(jarNo > 0) {
					nameSuffix = jarNo.ToString();
				}
				if(line.StartsWith("MIDlet-Name:")) {
					line = "MIDlet-Name: " + bookName + nameSuffix;
				}
				else if(line.StartsWith("MIDlet-Jar-URL:")) {
					line = "MIDlet-Jar-URL: " + bookName + nameSuffix + ".jar";
				}
				else if(line.StartsWith("MIDlet-Jar-Size:")) {
					line = "MIDlet-Jar-Size: " + jarFileSize;
				}
				else if(line.StartsWith("Book-Size:")) {
					line = "Book-Size: " + zipEntryBook.Size;
					bookSizeExists = true;
				}

				sw.WriteLine(line);
				line = sr.ReadLine();
			}
			if(!bookSizeExists) {
				sw.WriteLine("Book-Size: " + zipEntryBook.Size);
			}
			String bookEncoding = txtbxBookEncoding.Text;
			if(bookEncoding != null && bookEncoding.Length > 0) {
				sw.WriteLine("Book-Encoding: " + bookEncoding);
			}
			sw.WriteLine();
			sw.WriteLine();
			sw.Close();
			sr.Close();
			
			return jarFileSize;
		}
		
		
		private void skip(System.IO.Stream stream, long length) {
			long pos = 0;
			while(pos < length) {
				stream.ReadByte();
				pos++;
			}
		}
		void BtnCoverImageClick(object sender, System.EventArgs e)
		{
			openFileDialogCover.ShowDialog();
			if(openFileDialogCover.ShowDialog() == DialogResult.OK) {
				this.txtbxCoverImage.Text = openFileDialogCover.FileName;
			}
		}
		
		void BtnTargetDirClick(object sender, System.EventArgs e)
		{
			if(folderBrowserDialogDir.ShowDialog() == DialogResult.OK) {
				this.txtbxTargetDir.Text = folderBrowserDialogDir.SelectedPath;
			}
		}
		
		void BtnTxtFileClick(object sender, System.EventArgs e)
		{
			if(openFileDialogTxt.ShowDialog() == DialogResult.OK) {
				this.txtbxTxtFile.Text = openFileDialogTxt.FileName;
			}
		}
		
	}
}


